import type { EmscriptenFile, EmscriptenFileUrl } from "./message-types";
import { type HttpRequest, type HttpResponse } from "./http";
export interface WorkerProxyOptions {
    gradioWheelUrl: string;
    gradioClientWheelUrl: string;
    files: Record<string, EmscriptenFile | EmscriptenFileUrl>;
    requirements: string[];
    sharedWorkerMode: boolean;
}
export declare class WorkerProxy extends EventTarget {
    private worker;
    private postMessageTarget;
    private firstRunPromiseDelegate;
    constructor(options: WorkerProxyOptions);
    runPythonCode(code: string): Promise<void>;
    runPythonFile(path: string): Promise<void>;
    private postMessageAsync;
    private _processWorkerMessage;
    requestAsgi(scope: Record<string, unknown>): MessagePort;
    httpRequest(request: HttpRequest): Promise<HttpResponse>;
    writeFile(path: string, data: string | ArrayBufferView, opts?: Record<string, unknown>): Promise<void>;
    renameFile(oldPath: string, newPath: string): Promise<void>;
    unlink(path: string): Promise<void>;
    install(requirements: string[]): Promise<void>;
    terminate(): void;
}
//# sourceMappingURL=worker-proxy.d.ts.map